<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Smart Folder: Référence du fichier src/search_engine.c</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Smart Folder
   &#160;<span id="projectnumber">0.1</span>
   </div>
   <div id="projectbrief">Un répertoire virtuel de recherche de fichiers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('search__engine_8c.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Fonctions</a>  </div>
  <div class="headertitle">
<div class="title">Référence du fichier search_engine.c</div>  </div>
</div><!--header-->
<div class="contents">

<p>Contient les fonctions du moteur de recherche.  
<a href="#details">Plus de détails...</a></p>
<div class="textblock"><code>#include &quot;<a class="el" href="search__engine_8h_source.html">../inc/search_engine.h</a>&quot;</code><br />
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Fonctions</h2></td></tr>
<tr class="memitem:a28d51e7daa2e7831c1a180af6c9f9451"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8c.html#a28d51e7daa2e7831c1a180af6c9f9451">stop_search_engine</a> (void *arg)</td></tr>
<tr class="memdesc:a28d51e7daa2e7831c1a180af6c9f9451"><td class="mdescLeft">&#160;</td><td class="mdescRight">Thread pour arrêter le programme.  <a href="#a28d51e7daa2e7831c1a180af6c9f9451">Plus de détails...</a><br /></td></tr>
<tr class="separator:a28d51e7daa2e7831c1a180af6c9f9451"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a93cafba0c6047a838ce5d0628d3f1674"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8c.html#a93cafba0c6047a838ce5d0628d3f1674">search_engine</a> (char *dir_path, char *<a class="el" href="hash__table_8c.html#a5420849a0d0b03ddc3afbba911fd301a">search_path</a>, <a class="el" href="structexpression__t.html">expression_t</a> *strct)</td></tr>
<tr class="memdesc:a93cafba0c6047a838ce5d0628d3f1674"><td class="mdescLeft">&#160;</td><td class="mdescRight">Moteur de recherche.  <a href="#a93cafba0c6047a838ce5d0628d3f1674">Plus de détails...</a><br /></td></tr>
<tr class="separator:a93cafba0c6047a838ce5d0628d3f1674"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Description détaillée</h2>
<div class="textblock"><p>Contient les fonctions du moteur de recherche. </p>
<dl class="section author"><dt>Auteur</dt><dd>Abdennadher Raed &amp; Antoniadis Orphée </dd></dl>
<dl class="section version"><dt>Version</dt><dd>0.1 </dd></dl>
<dl class="section date"><dt>Date</dt><dd>27 janvier 2017 </dd></dl>
</div><h2 class="groupheader">Documentation des fonctions</h2>
<a id="a93cafba0c6047a838ce5d0628d3f1674"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a93cafba0c6047a838ce5d0628d3f1674">&#9670;&nbsp;</a></span>search_engine()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void search_engine </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>dir_path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>search_path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structexpression__t.html">expression_t</a> *&#160;</td>
          <td class="paramname"><em>strct</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Moteur de recherche. </p>
<p>C'est la fonction qui représente le noyau du programme. Elle effectue les taches suivantes :</p><ol type="1">
<li>Création et lancement du processus de recherche (fork)</li>
<li>Création et lancement du thread de terminaison du programme</li>
<li>Création du fichier qui va contenir le PID du programme</li>
<li>Initialisation du table de hachage qui va contenir les hashs des paths dans le dossier <em>dir_path</em> </li>
<li>Appel au crawler, filter, et puis linker pour finalement obtenir les fichiers recherchés.</li>
</ol>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">dir_path</td><td>Le nom du répertoire du résultat de recherche </td></tr>
    <tr><td class="paramname">search_path</td><td>Le nom du répertoire où la recherche va être effectuer </td></tr>
    <tr><td class="paramname">strct</td><td>Structure qui contient les informations de critères de recherche </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a28d51e7daa2e7831c1a180af6c9f9451"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a28d51e7daa2e7831c1a180af6c9f9451">&#9670;&nbsp;</a></span>stop_search_engine()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void * stop_search_engine </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>arg</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Thread pour arrêter le programme. </p>
<p>Ce thread va être lancé au démarrage du programme. Il va tourner tant qu'il ne reçoit pas le signal SIGINT. S'il le reçoit, il va mettre la valeur du pointeur en paramètre <em>arg</em> à <em>1</em>.</p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">arg</td><td>Pointeur sur la variable qui permet au programme de tourner en continue. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Renvoie</dt><dd>NULL </dd></dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="search__engine_8c.html">search_engine.c</a></li>
    <li class="footer">Généré par
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
